Index: /extensions/Subscribe_to_comments/main.inc.php
===================================================================
--- /extensions/Subscribe_to_comments/main.inc.php	(revision 26138)
+++ /extensions/Subscribe_to_comments/main.inc.php	(revision 26139)
@@ -1,17 +1,17 @@
-<?php 
+<?php
 /*
 Plugin Name: Subscribe To Comments
 Version: auto
 Description: This plugin allows to subscribe to comments by email.
-Plugin URI: http://piwigo.org/ext/extension_view.php?eid=587
+Plugin URI: auto
 Author: Mistic
 Author URI: http://www.strangeplanet.fr
 */
 
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');
 
 global $prefixeTable;
 
-defined('SUBSCRIBE_TO_ID') or define('SUBSCRIBE_TO_ID', basename(dirname(__FILE__)));
+define('SUBSCRIBE_TO_ID',      basename(dirname(__FILE__)));
 define('SUBSCRIBE_TO_PATH' ,   PHPWG_PLUGINS_PATH . SUBSCRIBE_TO_ID . '/');
 define('SUBSCRIBE_TO_TABLE',   $prefixeTable . 'subscribe_to_comments');
@@ -25,77 +25,60 @@
 function stc_init()
 {
-  global $conf, $user, $pwg_loaded_plugins;
-  
+  global $conf, $user;
+
   // no comments on luciano
-  if ($user['theme'] == 'luciano') return;
-  
-  // apply upgrade if needed
-  if (
-    SUBSCRIBE_TO_VERSION == 'auto' or
-    $pwg_loaded_plugins[SUBSCRIBE_TO_ID]['version'] == 'auto' or
-    version_compare($pwg_loaded_plugins[SUBSCRIBE_TO_ID]['version'], SUBSCRIBE_TO_VERSION, '<')
-  )
+  if ($user['theme'] == 'luciano')
   {
-    include_once(SUBSCRIBE_TO_PATH . 'include/install.inc.php');
-    stc_install();
-    
-    if ( $pwg_loaded_plugins[SUBSCRIBE_TO_ID]['version'] != 'auto' and SUBSCRIBE_TO_VERSION != 'auto' )
-    {
-      $query = '
-UPDATE '. PLUGINS_TABLE .'
-SET version = "'. SUBSCRIBE_TO_VERSION .'"
-WHERE id = "'. SUBSCRIBE_TO_ID .'"';
-      pwg_query($query);
-      
-      $pwg_loaded_plugins[SUBSCRIBE_TO_ID]['version'] = SUBSCRIBE_TO_VERSION;
-      
-      if (defined('IN_ADMIN'))
-      {
-        $_SESSION['page_infos'][] = 'Subscribe to comments updated to version '. SUBSCRIBE_TO_VERSION;
-      }
-    }
+    return;
   }
-  
-  // load language and conf
+
+  include_once(SUBSCRIBE_TO_PATH . 'maintain.inc.php');
+  $maintain = new Subscribe_to_Comments_maintain(SUBSCRIBE_TO_ID);
+  $maintain->autoUpdate(SUBSCRIBE_TO_VERSION, 'install');
+
+
   load_language('plugin.lang', SUBSCRIBE_TO_PATH);
   $conf['Subscribe_to_Comments'] = unserialize($conf['Subscribe_to_Comments']);
-  
-  
+
+
   include_once(SUBSCRIBE_TO_PATH.'include/functions.inc.php');
-  include_once(SUBSCRIBE_TO_PATH.'include/subscribe_to_comments.inc.php');
+  include_once(SUBSCRIBE_TO_PATH.'include/events.inc.php');
 
-  
+
+  if (!defined('IN_ADMIN'))
+  {
+    // subscribe
+    add_event_handler('loc_end_picture', 'stc_on_picture');
+    add_event_handler('loc_begin_coa', 'stc_on_album');
+
+    // management
+    add_event_handler('loc_end_section_init', 'stc_detect_section');
+    add_event_handler('loc_begin_page_header', 'stc_load_section');
+
+    // profile link
+    add_event_handler('loc_begin_profile', 'stc_profile_link');
+  }
+  else
+  {
+    // config page
+    add_event_handler('get_admin_plugin_menu_links', 'stc_admin_menu');
+  }
+
   // send mails
   add_event_handler('user_comment_insertion', 'stc_comment_insertion');
   add_event_handler('user_comment_validation', 'stc_comment_validation', EVENT_HANDLER_PRIORITY_NEUTRAL, 2);
 
-  // subscribe
-  add_event_handler('loc_end_picture', 'stc_on_picture');
-  add_event_handler('loc_begin_coa', 'stc_on_album');
-
-  // management
-  add_event_handler('loc_end_section_init', 'stc_detect_section');
-  add_event_handler('loc_begin_page_header', 'stc_load_section');
-  
   // items deletion
   add_event_handler('begin_delete_elements', 'stc_delete_elements');
   add_event_handler('delete_categories', 'stc_delete_categories');
-
-  // profile link
-  add_event_handler('loc_begin_profile', 'stc_profile_link');
-  
-  // config page
-  add_event_handler('get_admin_plugin_menu_links', 'stc_admin_menu');
 }
 
 
-function stc_admin_menu($menu) 
+function stc_admin_menu($menu)
 {
-  array_push($menu, array(
+  $menu[] = array(
     'NAME' => 'Subscribe to Comments',
     'URL' => SUBSCRIBE_TO_ADMIN,
-  ));
+    );
   return $menu;
 }
-
-?>
Index: /extensions/Subscribe_to_comments/maintain.inc.php
===================================================================
--- /extensions/Subscribe_to_comments/maintain.inc.php	(revision 26138)
+++ /extensions/Subscribe_to_comments/maintain.inc.php	(revision 26139)
@@ -1,29 +1,126 @@
 <?php
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');
 
-defined('SUBSCRIBE_TO_ID') or define('SUBSCRIBE_TO_ID', basename(dirname(__FILE__)));
-include_once(PHPWG_PLUGINS_PATH . SUBSCRIBE_TO_ID . '/include/install.inc.php');
-  
+class Subscribe_to_Comments_maintain extends PluginMaintain
+{
+  private $installed = false;
 
-function plugin_install() 
-{
-  stc_install();
-  define('stc_installed', true);
-}
+  private $default_conf = array(
+    'notify_admin_on_subscribe' => false,
+    'allow_global_subscriptions' => true,
+    );
 
-function plugin_activate()
-{
-  if (!defined('stc_installed'))
+  private $table;
+
+  function __construct($plugin_id)
   {
-    stc_install();
+    parent::__construct($plugin_id);
+
+    global $prefixeTable;
+    $this->table = $prefixeTable . 'subscribe_to_comments';
+  }
+
+  function install($plugin_version, &$errors=array())
+  {
+    global $conf;
+
+    // config parameter
+    if (empty($conf['Subscribe_to_Comments']))
+    {
+      $conf['Subscribe_to_Comments'] = serialize($this->default_config);
+      conf_update_param('Subscribe_to_Comments', $conf['Subscribe_to_Comments']);
+    }
+
+    // subscriptions table
+    pwg_query('
+CREATE TABLE IF NOT EXISTS `'. $this->table .'` (
+  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
+  `type` enum("image","album-images","album","all-images","all-albums") NOT NULL DEFAULT "image",
+  `element_id` mediumint(8) DEFAULT NULL,
+  `language` varchar(64) NOT NULL,
+  `email` varchar(255) NOT NULL,
+  `registration_date` datetime NOT NULL,
+  `validated` enum("true","false") NOT NULL DEFAULT "false",
+  PRIMARY KEY (`id`),
+  UNIQUE KEY `UNIQUE` (`email` , `type` , `element_id`)
+) DEFAULT CHARSET=utf8
+;');
+
+    // table structure upgrade in 1.1
+    $result = pwg_query('SHOW COLUMNS FROM `'. $this->table .'` LIKE "element_id";');
+    if (!pwg_db_num_rows($result))
+    {
+      // backup subscriptions
+      $query = 'SELECT * FROM `'. $this->table .'` ORDER BY registration_date;';
+      $subscriptions = query2array($query, 'id');
+
+      // upgrade the table
+      pwg_query('TRUNCATE TABLE `'. $this->table .'`;');
+      pwg_query('ALTER TABLE `'. $this->table .'` DROP `image_id`, DROP `category_id`;');
+      pwg_query('ALTER TABLE `'. $this->table .'` AUTO_INCREMENT = 1;');
+
+      $query = '
+ALTER TABLE `'. $this->table .'`
+  ADD `type` enum("image", "album-images", "album", "all-images", "all-albums") NOT NULL DEFAULT "image" AFTER `id`,
+  ADD `element_id` mediumint(8) NULL AFTER `type`,
+  ADD `language` varchar(64) NOT NULL AFTER `element_id`
+;';
+      pwg_query($query);
+
+      pwg_query('ALTER TABLE `'. $this->table .'`  DROP INDEX `UNIQUE`, ADD UNIQUE `UNIQUE` (`email`, `type`, `element_id`);');
+
+      // convert datas and fill the table
+      $inserts = array();
+
+      foreach ($subscriptions as $row)
+      {
+        if (!empty($row['category_id']))
+        {
+          $row['type'] = 'album';
+          $row['element_id'] = $row['category_id'];
+        }
+        else if (!empty($row['image_id']))
+        {
+          $row['type'] = 'image';
+          $row['element_id'] = $row['image_id'];
+        }
+        else
+        {
+          continue;
+        }
+
+        unset($row['id'], $row['image_id'], $row['category_id']);
+        $row['language'] = 'en_UK';
+
+        array_push($inserts, $row);
+      }
+
+      if (count($inserts) > 0)
+      {
+        $dbfields = array('type', 'element_id', 'language', 'email', 'registration_date', 'validated');
+        mass_inserts($this->table, $dbfields, $inserts);
+      }
+    }
+
+    $this->installed = true;
+  }
+
+  function activate($plugin_version, &$errors=array())
+  {
+    if (!$this->installed)
+    {
+      $this->install($plugin_version, $errors);
+    }
+  }
+
+  function deactivate()
+  {
+  }
+
+  function uninstall()
+  {
+    conf_delete_param('Subscribe_to_Comments');
+
+    pwg_query('DROP TABLE `'. $this->table .'`;');
   }
 }
-
-function plugin_uninstall() 
-{
-  global $prefixeTable;
-  
-  pwg_query('DROP TABLE `'. $prefixeTable . 'subscribe_to_comments`;');
-  pwg_query('DELETE FROM `'. CONFIG_TABLE .'` WHERE param = "Subscribe_to_Comments" LIMIT 1;');
-}
-?>
